/*
 * simple sparse demo
 */

#define kernel __attribute__((address_space(0)))
#define user __attribute__((address_space(1), noderef))

void copy_to_user(const void kernel*, void user*);

void
okay(void kernel *k, void user *u)
{
	copy_to_user(k, u);
}

void
notokay(void kernel *k, void user *u)
{
	copy_to_user(u, k);
	copy_to_user(k, k);
	copy_to_user(u, u);
}

#define acquires(x) __attribute__((context(x, 0, 1)))
#define releases(x) __attribute__((context(x, 1, 0)))

void lock() acquires(x);
void unlock() releases(x);

void
okay1(void)
{
	lock();
	unlock();
	
	for(;;){
		lock();
		lock();
		unlock();
		unlock();
	}
	
	lock(); /* not reached! */
}

void
notokay1(void)
{
	lock();
}

void
notokay2(void)
{
	unlock();
}

void
notokay3(void)
{
	lock();
	lock();
	unlock();
}

void
notokay4(void)
{
	int i;
	
	for(i=0; i<2; i++)
		lock();
	unlock();
	unlock();
}

