extern int printf(char*, ...);
extern int strcmp(const char *s1, const char *s2);
extern char *strchr(const char *s, int c);

int failed;
int checked;
const char *lastloc;
const char *laststring;

void
assertstring(const char *want, const char *got)
{
	if(strcmp(want, got) != 0) {
		printf("FAILURE: Expected %s, got %s\n", want, got);
		failed = 1;
	}
}

void
assertchecked(const char *loc, const char *string)
{
	if(checked) {
		const char *nloc;
		nloc = strchr(lastloc, '/');
		if(nloc)
			++nloc;
		else
			nloc = lastloc;
		assertstring(loc, nloc);
		assertstring(string, laststring);
	} else {
		printf("FAILURE: ALEF_check not called\n");
		failed = 1;
	}
	checked = 0;
}

void
assertnotchecked(void)
{
	if(checked) {
		printf("FAILURE: ALEF_check called\n");
		failed = 1;
	}
	checked = 0;
}

void
ALEF_check(const char *loc, const char *string)
{
	checked = 1;
	lastloc = loc;
	laststring = string;
}

int
main(int argc, char **argv)
{
	check 2+2 == 5;
	assertchecked("alef-check.c:59", "2 + 2 == 5");
	check 2+2 == 4;
	assertnotchecked();
	check 1 == 0, "foo";
	assertchecked("alef-check.c:63", "foo");

	if(!failed) {
		printf("PASSED\n");
		return 0;
	}
	return 1;
}
