// Avoid conflicting with other header files (ie pcre.h)
#define size_t int
extern void *malloc(size_t size);
extern void free(void *ptr);
extern void *memcpy(void *dest, const void *src, size_t n);

// push x
// call *y
// add $0x4, %esp
// ret

// XXX Due to limitations with initializers, the size must be given
// and we can't break the string across multiple lines or use an array
// initializer.  Also, xTc mysteriously omitted support for hex
// escapes, so we use octal.
static char closurecode[16] = "\150\0\0\0\0\377\025\0\0\0\0\203\304\004\303";

struct closure_t
{
	char code[sizeof(closurecode)];
	void *lifted;
};

static void *allocClosure(size_t envSize, void *lifted, void **envout) {
	struct closure_t *c =
		(struct closure_t*)malloc(sizeof(struct closure_t) + envSize);
	memcpy(c->code, closurecode, sizeof(closurecode));
	*envout = c + sizeof(struct closure_t);
	// Fill in x with the environment structure pointer
	*(void**)(c->code+1) = *envout;
	// Fill in y with the address of the pointer to the lifted
	// function
	c->lifted = lifted;
	*(void**)(c->code+7) = &c->lifted;
	return c;
}

static void freefn(void *f)
{
	free(f);
}

#undef size_t
