#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <pcre.h>

static void
check()
{
	$0.str; // warning

	if("foo" =~ m/foo/){
		$0.str; // ok
		$1.str; // warning
	}
	else if("foo" =~ m/foo(foo)(foo)/){
		$0.str; // ok
		$1.str; // ok
		$2.str; // ok
		$3.str; // warning
	}
	$0.str; // ok
	$1.str; // warning
	$2.str; // warning
	$3.str; // warning
}

int
main()
{
	printf("Checking: \"foo\" =~ m/foo/\n");
	if("foo" =~ m/foo/){
		printf("Matched!\n");
		printf("$0.str   = %s\n", $0.str);
	}
	else
		printf("No match!\n");

	printf("Checking: \"__foobarbaz__\" =~ m/foo(bar)(?P<sub>baz)/\n");
	if("__foobarbaz__" =~ m/foo(bar)(?P<sub>baz)/){
		printf("Matched!\n");
		printf("$0.str   = %s\n", $0.str);
		printf("$0.start = %s\n", $0.start);
		printf("$0.end   = %s\n", $0.end);
		printf("$0.len = %d\n", $0.len);
		printf("$1.str   = %s\n", $1.str);
		printf("$1.start = %s\n", $1.start);
		printf("$1.end   = %s\n", $1.end);
		printf("$1.len = %d\n", $1.len);
		printf("$2.str   = %s\n", $2.str);
		printf("$2.start = %s\n", $2.start);
		printf("$2.end   = %s\n", $2.end);
		printf("$2.len = %d\n", $2.len);
		printf("$<sub>.str   = %s\n", $<sub>.str);
		printf("$<sub>.start = %s\n", $<sub>.start);
		printf("$<sub>.end   = %s\n", $<sub>.end);
		printf("$<sub>.len = %d\n", $<sub>.len);
	}
	else
		printf("No match!\n");

	printf("Checking: \"test\" =~ m/TEST/i\n");
	if("test" =~ m/TEST/i){
		printf("Matched!\n");
		printf("$0.str   = %s\n", $0.str);
	}
	else
		printf("No match!\n");

	printf("Checking foofoofoofoofoo\n");
	while("foofoofoofoofoo" =~ m/foo/g){
		printf("Matched!\n");
		printf("$0.str   = %s\n", $0.str);
	}
	printf("Done matching!\n");
}

