# define __user		__attribute__((noderef, address_space(1)))
# define __kernel	/* default address space */
# define __safe		__attribute__((safe))
# define __force	__attribute__((force))
# define __nocast	__attribute__((nocast))
# define __iomem	__attribute__((noderef, address_space(2)))

extern void* malloc(int);

typedef struct Lock Lock;
tracked($A) Lock* lockcreate(void) [new $A@unlocked];

void lock(tracked($A) Lock*)     [$A@unlocked->@locked];
void unlock(tracked($A) Lock*)   [$A@locked->@unlocked];
void freelock(tracked($A) Lock*) [-$A@unlocked];
void douser(tracked($A) Lock*, $A:void __user*) [$A@locked];
void dokernel(tracked($A) Lock*, $A:void *)     [$A@locked];

void
main()
{
	$X:int* k;
	$X:int __user* u;
	// stored = {}
	// held   = {}
	tracked($X) Lock* l;
	// stored = {}
	// held   = {}
	l = lockcreate();
	// stored = {X}
	// held   = {X@unlocked}
	k = malloc(sizeof *k);
	u = malloc(sizeof *u);
	*k = 5;
	*u = 5;                // deref warning
	lock(l);
	// stored = {X}
	// held   = {X@locked}
	douser(l, k);          // adds addr space warning
	douser(l, u);
	dokernel(l, k);
	dokernel(l, u);        // drops addr space warning
	unlock(l);
	// stored = {X}
	// held   = {X@unlocked}
	freelock(l);
	// stored = {X}
	// held   = {}
	*k = 6;           // bad!
}

