#include "a.h"
#include "code.h"

Expr::~Expr() { }

Loc*
Expr::lea(Compile *cs, int foo)
{
	return nil;
}

#define SIG(E, s) \
	static vector<ExprSig> v_##s(s, s+nelem(s)); \
	SIG1(E, s)

#define SIG1(E, s) \
	const vector<ExprSig>& E::sigs() { \
		return v_##s; \
	}

static ExprSig addsig[] =
{
	{ xaddi, typeint(), typeint(), typeint() },
	{ xaddf, typefloat(), typefloat(), typefloat() },
	{ xadds, typestring(), typestring(), typestring() },
};
SIG(ExprAdd, addsig)
SIG1(ExprAddEq, addsig)

static ExprSig subsig[] =
{
	{ xsubi, typeint(), typeint(), typeint() },
	{ xsubf, typefloat(), typefloat(), typefloat() },
};
SIG(ExprSub, subsig)
SIG1(ExprSubEq, subsig)

static ExprSig mulsig[] =
{
	{ xmuli, typeint(), typeint(), typeint() },
	{ xmulf, typefloat(), typefloat(), typefloat() },
};
SIG(ExprMul, mulsig)
SIG1(ExprMulEq, mulsig)

static ExprSig divsig[] =
{
	{ xdivi, typeint(), typeint(), typeint() },
	{ xdivf, typefloat(), typefloat(), typefloat() },
};
SIG(ExprDiv, divsig)
SIG1(ExprDivEq, divsig)

static ExprSig modsig[] =
{
	{ xmodi, typeint(), typeint(), typeint() },
	{ xmodf, typefloat(), typefloat(), typefloat() },
};
SIG(ExprMod, modsig)
SIG1(ExprModEq, modsig)

static ExprSig andsig[] =
{
	{ xandi, typeint(), typeint(), typeint() },
};
SIG(ExprAnd, andsig)
SIG1(ExprAndEq, andsig)

static ExprSig orsig[] = 
{
	{ xori, typeint(), typeint(), typeint() },
};
SIG(ExprOr, orsig)
SIG1(ExprOrEq, orsig)

static ExprSig xorsig[] =
{
	{ xxori, typeint(), typeint(), typeint() },
};
SIG(ExprXor, xorsig)
SIG1(ExprXorEq, xorsig)

static ExprSig lshsig[] =
{
	{ xlshi, typeint(), typeint(), typeint() },
};
SIG(ExprLsh, lshsig)
SIG1(ExprLshEq, lshsig)

static ExprSig rshsig[] =
{
	{ xrshi, typeint(), typeint(), typeint() },
};
SIG(ExprRsh, rshsig)
SIG1(ExprRshEq, rshsig)

static ExprSig lesig[] =
{
	{ xlei, typeint(), typeint(), typebool() },
	{ xlei, typebool(), typebool(), typebool() },
	{ xles, typestring(), typestring(), typebool() },
	{ xlef, typefloat(), typefloat(), typebool() },
};
SIG(ExprLe, lesig)

static ExprSig ltsig[] =
{
	{ xlti, typeint(), typeint(), typebool() },
	{ xlti, typebool(), typebool(), typebool() },
	{ xlts, typestring(), typestring(), typebool() },
	{ xltf, typefloat(), typefloat(), typebool() },
};
SIG(ExprLt, ltsig)

static ExprSig gesig[] =
{
	{ xgei, typeint(), typeint(), typebool() },
	{ xgei, typebool(), typebool(), typebool() },
	{ xges, typestring(), typestring(), typebool() },
	{ xgef, typefloat(), typefloat(), typebool() },
};
SIG(ExprGe, gesig)

static ExprSig gtsig[] =
{
	{ xgti, typeint(), typeint(), typebool() },
	{ xgti, typebool(), typebool(), typebool() },
	{ xgts, typestring(), typestring(), typebool() },
	{ xgtf, typefloat(), typefloat(), typebool() },
};
SIG(ExprGt, gtsig)

static ExprSig twidsig[] =
{
	{ xtwidi, typeint(), nil, typeint() },
};
SIG(ExprTwid, twidsig)

static ExprSig possig[] =
{
	{ xposi, typeint(), nil, typeint() },
	{ xposf, typefloat(), nil, typefloat() },
};
SIG(ExprPos, possig)

static ExprSig negsig[] =
{
	{ xnegi, typeint(), nil, typeint() },
	{ xnegf, typefloat(), nil, typefloat() },
};
SIG(ExprNeg, negsig)

static ExprSig notsig[] =
{
	{ xnoti, typebool(), nil, typebool() },
};
SIG(ExprNot, notsig)

const vector<ExprSig>&
ExprCode::sigs()
{
	static vector<ExprSig> v;
	
	panic("exprcode::Sigs");
	return v;
}
