// Lazy, but simple garbage collector

#include "a.h"

DEFINE_int32(arenasize, 10000000, "Garbage collection arena size.");

int memtot;

// Garbage-collected (ha!) allocator.
void*
galloc(int n)
{
	void *v;
	
	memtot += n;
	if(FLAGS_arenasize == 0){
		v = emalloc(n);
		return v;
	}else{
		// Allocate in arenas to reduce per-block overhead.
		static char *chunk;
		static int nchunk;

		n = (n+7)&~7;
		if(nchunk < n){
			nchunk = n;
			if(FLAGS_arenasize > nchunk)
				nchunk = FLAGS_arenasize;
			chunk = (char*)emalloc(nchunk);
		}
		v = chunk;
		chunk += n;
		nchunk -= n;
		return v;
	}
}
