#include "a.h"

void
StmtForList::typecheck(Typecheck *tc)
{
	Type *t;
	Name hd, tl, _a, _i, _l, _m;

	typecheckexpr(tc, cond_, Value);
	t = cond_->type_;
	if(t == nil)
		return;
	if(t->op == TypeArray){
		// for(x in a) body;
		//	becomes
		// {	_a := a;
		//	_l := length(_a);
		//	for(_i := 0; _i < _l; _i+=1){ 
		//		x := _a[_i]; 
		//		body;
		// }}
		_a = nameof("@a");
		_i = nameof("@i");
		_l = nameof("@l");
		expanded_ = new StmtList(list3(asyntax,
			(Stmt*)new StmtExpr(
				new ExprDeclEq(new ExprName(_a),
					nil,
					cond_)),
			(Stmt*)new StmtExpr(
				new ExprDeclEq(new ExprName(_l),
					nil,
					new ExprLength(new ExprName(_a)))),
			(Stmt*)new StmtFor(
				new ExprDeclEq(new ExprName(_i),
					nil,
					new ExprInteger(0)),
				new ExprLt(
					new ExprName(_i),
					new ExprName(_l)),
				new ExprAddEq(
					new ExprName(_i),
					new ExprInteger(1)),
				new StmtList(list2(asyntax,
						(Stmt*)new StmtExpr(new ExprDeclEq(expr_,
							(Type*)nil,
							new ExprArray(new ExprName(_a), new ExprName(_i)))),
						body_)))));
	}
	else if(t->op == TypeList){
		// for(x in l) body;
		//	becomes
		// for(_l := l; _l; _l=_l.tl){ 
		//	x := _l.hd; 
		//	body;
		// }
		_l = nameof("@l");
		hd = nameof("hd");
		tl = nameof("tl");
		expanded_ = new StmtList(list1(asyntax, 
			(Stmt*)new StmtFor(
				new ExprDeclEq(new ExprName(_l),
					nil,
					cond_),
				new ExprName(_l),
				new ExprEq(new ExprName(_l),
					new ExprDot(new ExprName(_l), tl)),
				new StmtList(
					list2(asyntax,
						(Stmt*)new StmtExpr(new ExprDeclEq(expr_,
							(Type*)nil,
							new ExprDot(new ExprName(_l), hd))),
						body_)))));
	}
	else if(t->op == TypeMap){
		// for((k,v) in m) body;
		//	becomes
		// {	_m := m;
		//	for(_i := _m; ++_i; ){ 
		//		(k,v) := _i;
		//		body;
		// }}
		ExprTuple *et;
		if((et = expr_->exprtuple()) == nil || et->exprs_.size() != 2)
			error(line_, "bad map iteration; expected (key,value) pair");
		_m = nameof("@m");
		_i = nameof("@i");
		expanded_ = new StmtList(list2(asyntax, 
			(Stmt*)new StmtExpr(
				new ExprDeclEq(new ExprName(_m),
					nil,
					cond_)),
			(Stmt*)new StmtFor(
				new ExprDeclEq(
					new ExprName(_i),
					nil,
					new ExprConvert(new ExprName(_m), typemapiter(t->left, t->right))),
				new ExprPreInc(new ExprName(_i)),
				nil,
				new StmtList(list2(asyntax,
					(Stmt*)new StmtExpr(new ExprDeclEq(expr_,
							(Type*)nil,
							new ExprConvert(new ExprName(_i), typetuple(list2(asyntax, t->left, t->right))))),
					body_)))));
	}
	else{
		error(line_, "cannot iterate on type %T", t);
		return;
	}
	typecheckstmt(tc, expanded_);
}
