typedef struct DScratch DScratch;
typedef struct DState DState;

template<typename T>
struct DFA
{
	NFA *nfa;
	DScratch *tmp;
	DState *dead;
	DState *start;
	DState **hash;
	int nhash;
	int nstate;
	int dirty;
};

struct DScratch
{
	NState **nstate;
	int nnstate;
};

enum
{
	Eol = 256,
	Bol = 257
};
struct DState
{
	DState *next[257];
	int id;
	DState *hash;
	NState **nstate;
	int nnstate;
	int match;
	List<void*> *val;
};

List<void*>	*_rundfa(DFA<void*>*, char*, char**);
int	_addtodfa(DFA<void*>*, char*, int, int, void*);
DFA<void*>	*_mkdfa();

template<typename T>
List<T*> *rundfa(DFA<T*> *dfa, char *p, char **pp)
{
	return (List<T*>*)_rundfa((DFA<void*>*)dfa, p, pp);
}

template<typename T>
int
addtodfa(DFA<T*> *dfa, char *re, int mode, int prec, T *val)
{
	return _addtodfa((DFA<void*>*)dfa, re, mode, prec, (void*)val);
}

template<typename T>
DFA<T*>*
mkdfa()
{
	return (DFA<T*>*)_mkdfa();
}

