#include "u.h"
#include "emalloc.h"
#include "panic.h"

void*
emalloc(int n)
{
	void *v;

	v = malloc(n);
	if(v == nil)
		panic("out of memory");
	memset(v, 0, n);
	return v;
}

void*
emallocnz(int n)
{
	void *v;

	v = malloc(n);
	if(v == nil)
		panic("out of memory");
	memset(v, 0, n);
	return v;
}

void*
erealloc(void *v, int n)
{
	v = realloc(v, n);
	if(v == nil)
		panic("out of memory");
	return v;
}

void*
erealloczero(void *v, int old, int nw)
{
	v = realloc(v, nw);
	if(v == nil)
		panic("out of memory");
	if(nw > old)
		memset((char*)v + old, 0, nw - old);
	return v;
}

void
efree(void *v)
{
	free(v);
}

char*
estrdup(char *s)
{
	char *t;
	
	t = (char*)emalloc(strlen(s)+1);
	strcpy(t, s);
	return t;
}

void*
ecopy(void *v, int n)
{
	void *nv;
	
	nv = emalloc(n);
	memmove(nv, v, n);
	return nv;
}

