#include "u.h"
#include "name.h"
#include "line.h"
#include "utf.h"
#include "fmt.h"

int errors;
int warnings;
int byte_addressing;
int supress_errors;

Line ZL;

void
error(Line l, char *fmt, ...)
{
	va_list arg;
	
	if(supress_errors)
		return;
	fprint(2, "%L: error: ", l);
	va_start(arg, fmt);
	vfprint(2, fmt, arg);
	va_end(arg);
	fprint(2, "\n");
	errors++;
}

void
warn(Line l, char *fmt, ...)
{
	va_list arg;
	
	fprint(2, "%L: warning: ", l);
	va_start(arg, fmt);
	vfprint(2, fmt, arg);
	va_end(arg);
	fprint(2, "\n");
	warnings++;
}

int
Lconv(Fmt *f)
{
	Line l;
	
	l = va_arg(f->args, Line);
	if(byte_addressing){
		if(l.byte1 == 0 || l.byte == l.byte1)
			return fmtprint(f, "%s:#%d", l.file, l.byte);
		return fmtprint(f, "%s:#%d,#%d", l.file, l.byte, l.byte1);
	}
	if(l.line1 == 0 || l.line == l.line1)
		return fmtprint(f, "%s:%d", l.file, l.line);
	return fmtprint(f, "%s:%d,%d", l.file, l.line, l.line1);
}

