// This is a lot of C++ wrapping to make Name behave like
//
//	typedef char *Name;
//
// except that comparing names to char* directly is detected
// by the compiler, as is assigning char* to Name.

struct Name {
	struct Null;	// Null* is surrogate for null pointer
	char *s_;
	bool operator==(Name n) { return s_ == n.s_; }
	bool operator==(Null *z) { return s_ == nil; }
	operator char*() { return s_; }
	Name& operator=(Null *z) { s_ = nil; return *this; }
	static Name null;

	static void init();
	static Name slot;   // some common names
	static Name merge;
	static Name prev;
	static Name next;
};

Name nameof(const char *str);
Name nameofn(const char *str, int len);
Name nameprint(char *fmt, ...);

inline Name namecast(char *v) { Name n = { v }; return n; }

const char *n2s(Name name);
